#include <amxmodx>
#include <fakemeta>
#include <fun>
#include <hamsandwich>
#define TASK_1 33
#define TASK_2 66
#define TASK_3 99
#define TASK_4 132
#define TASK_5 165
#define TASK_6 198
#define TASK_0 231

#define X get_pcvar_float(tasktime)
#define TASK1TIME  X/6
#define TASK2TIME 2*X/6
#define TASK3TIME 3*X/6
#define TASK4TIME 4*X/6
#define TASK5TIME 5*X/6
#define TASK6TIME X
#define VISIBILITY get_pcvar_num(visibility)

new const IN_MOVING = (IN_ATTACK | IN_FORWARD | IN_BACK | IN_MOVELEFT | IN_MOVERIGHT | IN_JUMP)

#define PLUGIN "knifeinvis"
#define VERSION "1.2"
#define AUTHOR "Tolsty"

new visibility;
new tasktime;
new amx_knifeinvis

new visible[33];
new start[33];
new stop[33];
new info[33];

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_forward(FM_CmdStart, "fwdCmdStart", 0);
	register_event("Damage", "event_damage", "be" );
	visibility = register_cvar("amx_visibility", "30"); // 0 - 225
	tasktime = register_cvar("amx_tasktime", "30.0"); 
	amx_knifeinvis = register_cvar("amx_knifeinvis", "1"); 
	RegisterHam(Ham_Spawn, "player", "fw_PlayerSpawn", 1);
	register_dictionary("knifeinvis.txt");
}

public fw_PlayerSpawn(id) {
	stop[id] = false;
	visible[id] = true;
	start[id] = false;
}
public client_connect(id) {
	stop[id] = false;
	visible[id] = true;
	start[id] = false;
}
public event_damage(id){
	visible[id] = true;
}

public fwdCmdStart( id , ucHandle) {
	if( !get_pcvar_num(amx_knifeinvis) ) 
		return FMRES_IGNORED

	static button, weapon
	button = get_uc(ucHandle, UC_Buttons)
	weapon = get_user_weapon(id)

	if ( ( button & IN_MOVING || weapon != CSW_KNIFE) && info[id] && !stop[id]) {
		set_hudmessage(0, 200, 255, -1.0, -1.0, 1, 0.0, 4.0, 0.0, 0.0, 1);
		show_hudmessage(id, "%L", id, "INFO", X );
	}
	if ( button & IN_MOVING || weapon != CSW_KNIFE) {
		visible[id] = true;
		start[id] = false;
		remove_task( id+TASK_1 );  
		remove_task( id+TASK_2 ); 
		remove_task( id+TASK_3 ); 
		remove_task( id+TASK_4 ); 
		remove_task( id+TASK_5 ); 
		remove_task( id+TASK_6 );
		remove_task( id+TASK_0 );
	}
	else
		visible[id] = false;

	if ( stop[id] ) {
		if (weapon != CSW_KNIFE) {
			engclient_cmd(id, "weapon_knife")
		}
		return FMRES_IGNORED
	}
	
	if(  visible[id] && !start[id]) {
		info[id] = false;
		set_user_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, 255);

	}
	else if(!visible[id] && !start[id]) {
		taskset(id);
	}
	return FMRES_IGNORED;
}

public taskset(id) {
	start[id] = true;
	visible[id] = false;
	set_task(2.0, "status0", id+TASK_0);
	set_task( TASK1TIME,"status1", id+TASK_1 );
	set_task( TASK2TIME,"status2", id+TASK_2 );
	set_task( TASK3TIME,"status3", id+TASK_3 );
	set_task( TASK4TIME,"status4", id+TASK_4 );
	set_task( TASK5TIME,"status5", id+TASK_5 );
	set_task( TASK6TIME,"status6", id+TASK_6 );
}
			
public status0(id) {
	static i; i = id - TASK_0;
	info[i] = true;
	set_hudmessage(0, 200, 255, -1.0, -1.0, 1, 0.0, 12.0, 1.0, 0.0, 1);
	show_hudmessage(i, "%L [------] ", i, "AFTER");
}
public status1(id) {
	static i; i = id - TASK_1;
	set_hudmessage(0, 200, 255, -1.0, -1.0, 1, 0.0, TASK1TIME.0, 0.0, 0.0, 1);
	show_hudmessage(i, "%L [=-----] ", i, "AFTER");
}
public status2(id) {
	static i; i = id - TASK_2;
	set_hudmessage(255, 155, 0, -1.0, -1.0, 1, 0.0, TASK1TIME.0, 0.0, 0.0, 1);
	show_hudmessage(i, "%L [==----] ", i, "AFTER");
}
public status3(id) {
	static i; i = id - TASK_3;
	set_hudmessage(0, 200, 255, -1.0, -1.0, 1, 0.0, TASK1TIME.0, 0.0, 0.0, 1);
	show_hudmessage(i, "%L [===---] ", i, "AFTER");
}
public status4(id) {
	static i; i = id - TASK_4;
	set_hudmessage(255, 155, 0, -1.0, -1.0, 1, 0.0, TASK1TIME.0, 0.0, 0.0, 1);
	show_hudmessage(i, "%L [====--] ", i, "AFTER");
}
public status5(id) {
	static i; i = id - TASK_5;
	set_hudmessage(0, 200, 255, -1.0, -1.0, 1, 0.0, TASK1TIME.0, 0.0, 0.0, 1);
	show_hudmessage(i, "%L [=====-] ", i, "AFTER");
}
public status6(id) {
	static i; i = id - TASK_6; 
	set_user_rendering(i, kRenderFxGlowShell, 0, 0, 0, kRenderTransAlpha, VISIBILITY);
	stop[i] = true;
	set_hudmessage(0, 200, 155, -1.0, -1.0, 1, 0.0, 3.0, 0.0, 1.0, 1);
	show_hudmessage(i, "%L [======] ", i, "SET");
	client_print(i, print_chat , "%L", i, "INVIS")
}


